/*****************************************************************
  Einfuehrung in die Praktische Informatik I (Prof. P. Bastian)

  Übungsaufgabe zur Wiederholung von dynamischen Arrays und 
  zum Vergleich der Laufzeiten zwischen O(n^2) und O(n).

  Autoren: D.Kempf, O.Klein, A.Ngo 
*****************************************************************/

#include <iostream>
#include "fcpp.hh"
#include <ctime>  // clock()
#include <cmath>  // z.B.: std::pow(a,b), std::sin(x)

//
// Fehlende Funktionen zu Aufgabe 10.3 bitte hier einfügen.
//

void repeatTest( int n, bool logValues ){

  std::clock_t start;
  double duration;
    
  // Dynamisches Array erzeugen:
  double *a = new double[n];

  // Array mit zufälligen Werten belegen:
  start = std::clock();
  initialize( a, n );
  duration = ( std::clock() - start ) / (double) CLOCKS_PER_SEC;
  std::cout << "initialize() braucht " << duration << " Sekunden" << std::endl;
  if( logValues )
    printArray( a, n );

  // Dynamisches Array der selben Groesse erzeugen:
  double *meanArray1 = new double[n];
  start = std::clock();
  meanValues( meanArray1, a, n );
  duration = ( std::clock() - start ) / (double) CLOCKS_PER_SEC;
  std::cout << "meanValues() braucht " << duration << " Sekunden" << std::endl;
  if( logValues )
    printArray( meanArray1, n );

  // Dynamisches Array der selben Groesse erzeugen:
  double *meanArray2 = new double[n];
  start = std::clock();
  meanValuesFast( meanArray2, a, n );
  duration = ( std::clock() - start ) / (double) CLOCKS_PER_SEC;
  std::cout << "meanValuesFast() braucht " << duration << " Sekunden" << std::endl;
  if( logValues )
    printArray( meanArray2, n );

  // Aufräumen:
  if(a)
    delete a;

  if(meanArray1)
    delete meanArray1;

  if(meanArray2)
    delete meanArray2;

}



int main(int argc, char** argv){
  // Startanzahl nStart aus der Kommandozeile einlesen:
  int nStart = readarg_int(argc,argv,1);
  // Anzahl der Verdoppelungen von n aus der Kommandozeile einlesen:
  int nLevel = readarg_int(argc,argv,2);
  // Ein- und Ausschalten der Ausgabe der Daten
  int nVerbosity = readarg_int(argc,argv,3);
  for(int i=0;i<nLevel;++i){
    int n = nStart*std::pow(2,i);
    std::cout << std::endl;
    std::cout << "Level=" << i << "  n=" << n << std::endl;    
    repeatTest( n, nVerbosity );
  }
  return 0;
}
